<#if element.properties.enableComments! == 'true' >
    <style>
        .comments_thread {margin-bottom:15px;}
        .comment_icon {color: #ccc; display: inline-block; width: 17px; position:absolute; left: 2px;}
        .comment_meta {border-bottom:1px solid #ccc;}
        .comment_date {font-size:80% !important; color:#ccc; line-height: 15px;}
        .comment_message {padding: 0px 0px 5px;}
        .comment_message:after {content:""; clear:both; display: block;}
        .comment_message > div {padding: 0px 20px; position:relative; display:block; box-sizing:border-box;}
        .comment_attachments ul {list-style:none; padding:5px 0;}
        .comment_attachments ul li.image {display:inline-block; width:60px; height:60px; border:1px solid #ccc; overflow:hidden; margin:0 3px 3px 0px;}
        .comment_attachments ul li.image a {width:60px; height:60px; display:block; background-size:cover; }
        @media screen and (min-width:681px) { 
            .comment_message.twocolumns > div {float:left; min-height:1px;}
            .comment_message.twocolumns > div.comment_statusinfo {width: ${commentStatusWidth!};}
            .comment_message.twocolumns > div.comment_msg {width: calc(100% - ${commentStatusWidth!});}
        }
    </style>
    <#if element.properties.disabledAddNewComments! != 'true' >
        <div class="process-comment-container">
            <#list element.children as e>
                ${e.render(formData, includeMetaData!false)}
            </#list>
        </div>
    </#if>
    <#if element.properties.commentThreadMode! != 'disabled' >
        <div class="form-cell comments_thread">
            <#if comments?size == 0 >
                <p>@@process.message.noComment@@</p>
            <#else>
                <#list comments as comment>
                    <div class="comment">
                        <div class="comment_meta">
                            <a class="comment_user">${comment.createdByName!}</a>
                            <#if element.properties.showActivityName! == 'true' >
                                &bull; <span class="comment_activity_name">${comment.activityName!}</span>
                            </#if>
                        </div>
                        <div class="comment_date">
                            ${comment.dateCreated!}
                        </div>
                        <div class="comment_message <#if element.properties.commentThreadMode! == '' >twocolumns</#if>">
                            <#if comment.statusInfo! != '' && element.properties.commentThreadMode! != 'commentOnly' >
                                <div class="comment_statusinfo">
                                    <span class="comment_icon"><i class="fas fa-info-circle"></i></span>
                                    ${comment.statusInfo}
                                </div>
                            <#elseif element.properties.commentThreadMode! == ''>
                                <div class="comment_statusinfo">
                                </div>
                            </#if>
                            <#if comment.message! != '' && element.properties.commentThreadMode! != 'statusOnly'  >
                                <div class="comment_msg">
                                    <span class="comment_icon"><i class="fas fa-comment-dots"></i></span>
                                    <#if comment.messageType! == 'richtext'>
                                        ${comment.message!}
                                    <#else>
                                        ${comment.message!?html}
                                    </#if>
                                    <#if comment.attachment! != ''>
                                        <div class="comment_attachments">
                                            <ul>
                                                <#list comment.attachment!?split(";") as aValue>
                                                    <li class="${comment.attachmentType!}">
                                                        <#if comment.attachmentType! == 'file'>
                                                            <a href="${request.contextPath}${path!}${comment.id!}/${aValue}.?attachment=true" target="_blank" >${aValue}</a>
                                                        <#else>
                                                            <a href="${request.contextPath}${path!}${comment.id!}/${aValue}." target="_blank" class="image" style="background-image:url('${request.contextPath}${path!}${comment.id!}/${aValue}.thumb.jpg.');" >
                                                            </a>
                                                        </#if>
                                                    </li>
                                                </#list>
                                            </ul>
                                        </div>
                                    </#if>
                                </div>
                            </#if>
                        </div>
                    </div>
                </#list>
                <p style="display:none;"><a class="showMoreComments" style="cursor:pointer;">@@process.label.showMoreComments@@</a></p>
            </#if>
        </div>
    </#if>
    <script>
        $(function(){
            if ($(".comments_thread .comment").length > ${element.properties.noOfComments!}) {
                var num = ${element.properties.noOfComments!} - 1;
                $(".comments_thread .comment:gt("+num+")").hide();
                $(".showMoreComments").parent().show();
                $(".showMoreComments").on("click", function(){
                    $(".comments_thread .comment").show();
                    $(".showMoreComments").parent().hide();
                });
            }
        });
    </script>
</#if>
<#if element.properties.enableProcessStatus! == 'true' >
    <link rel="stylesheet" href="${request.contextPath}/plugin/org.joget.plugin.enterprise.ProcessStatusDatalistFormatter/css/processStatusFormatter.css" />
    <script>
        $(function(){
            var previousScrollTop = 0;
            $(window).scroll(function (e) { 
                if($("body").hasClass("psdf_stop_scrolling")) {
                    e.stopPropagation();
                    e.stopImmediatePropagation();
                    e.preventDefault();
                    $(window).scrollTop(previousScrollTop); 
                }
                previousScrollTop = $(window).scrollTop();
            });

            $("#form-canvas").before('<div id="process_status_div" style="text-align:right"><span class="process_status_dl_container" style="display: inline-block !important; position: relative;"></span></div>');
            var el = $("#process_status_div .process_status_dl_container");
            $(el).append('<div class="blockui"></div><div class="ps_progress_container"></div><div class="ps_iframe_container" style="display:none;"><iframe src=""></iframe></div>');
            $(el).find("iframe").on("load", function(){
                $(el).find("iframe").contents().find("#process-status-canvas").attr("style", "padding:15px;");

                var renderProgressBar = function() {
                    if ($(el).find("iframe").contents().find("#process-status-canvas .process_container .progress_bar").length > 0) {
                        $(el).find(".ps_progress_container").append($(el).find("iframe").contents().find("#process-status-canvas .process_container .progress_bar").first().clone(true));
                        $(el).css("width", "150px");
                        $(el).find(".ps_progress_container, .ps_progress_container .progress_bar").css("width", "150px");
                    } else {
                        setTimeout(function() {
                            renderProgressBar();
                        }, 100);
                    }
                };
                renderProgressBar();

                $(el).find(".ps_progress_container").on("click", function(){
                    var bodyheight = $("body").innerHeight();
                    $(".datalist-body-content").data("psdf_style", $(".datalist-body-content").attr("style"));
                    $(".datalist-body-content").attr("style", "overflow:visible;");
                    $("body").data("psdf_style", $("body").attr("style"));
                    $("body").attr("style", "height:auto !important;");

                    var height = $("body").height();
                    var top = $(this).offset().top;
                    var paddingBottom = 0;
                    if (top + 450 > height) {
                        paddingBottom =  top + 450 - height;
                        bodyheight = bodyheight - paddingBottom;
                        $("body").attr("style", "height:auto !important; padding-bottom:"+paddingBottom+"px !important;");
                    }

                    $(el).addClass("show");
                    $('html, body').animate({
                        scrollTop: top - 100
                    }, 200, function(){
                        $("body").addClass("psdf_stop_scrolling");
                    });
                });
                $(el).find(".blockui").on("click", function(){
                    $(el).removeClass("show");
                    var listStyle = $(".datalist-body-content").data("psdf_style");
                    if (listStyle === undefined) {
                        listStyle = "";
                    }
                    $(".datalist-body-content").attr("style", listStyle);
                    var bodyStyle = $("body").data("psdf_style");
                    if (bodyStyle === undefined) {
                        bodyStyle = "";
                    }
                    $("body").attr("style", bodyStyle);
                    $("body").removeClass("psdf_stop_scrolling");
                });

                $(el).addClass("ready");
            });
            $(el).find("iframe").attr("src", "${processStatusUrl!}");
        });
    </script>
</#if>
<#if element.properties.enableReassignment! == 'true' || renderClarificationDiv! == 'true'>
    <#if !(request.getAttribute("org.joget.process.AssignmentFormActions_EDITABLE")??) >
        <script type="text/javascript" src="${request.contextPath}/js/chosen/chosen.jquery.js"></script>
        <link rel="stylesheet" type="text/css" href="${request.contextPath}/js/chosen/chosen.css" />
    </#if>
</#if>
<#if element.properties.enableReassignment! == 'true' >
    <div class="process_reassignment_div" style="position:relative; display:none;">
        <div class="blockui" style="width:100vw; height: 100vh; position: fixed; top:0; left:0; z-index: 99998; background: #000; opacity: 0.5;"></div>
        <div class="process_reassignment_input" style="position:absolute; z-index: 100000; left: 165%; transform: translateX(-50%); top: -100px; padding:5px; background:#fff;">
            <div class='ui-screen-hidden'>
                <select id="process_reassign_user" name="process_reassign_user" style="display:none">
                    <option value=""></option>
                    <#list options as option>
                        <#if option.value! != '' && option.value! != username>
                            <option value="${option.value!?html}">${option.label!?html}</option>
                        </#if>
                    </#list>
                </select>
            </div>
            <div style="width: 0; height: 0; border-right: 5px solid transparent; border-left: 5px solid transparent; border-top: 10px solid #fff; position: absolute; right: 85%; bottom: -10px; transform: translateX(50%);"></div>
        </div>
    </div>
    <style>
        body .form-container .process_reassignment_div .chosen-container {width:250px !important; max-width:none;}
    </style>
    <script>
        $(function(){
            var button = $('#process_reassign');
            $(button).parent().append($('.process_reassignment_div'));

            var element = $('#process_reassign_user');
            if ($("body").hasClass("rtl")) {
                $(element).addClass("chosen-rtl");
            }
            $(element).chosen({width: "250px", placeholder_text : '@@process.label.selectUser@@'});
            var hidden = $(element).closest(".ui-screen-hidden");
            $(hidden).find(".chosen-container").insertAfter(hidden);

            var unblock = function () {
                setTimeout(function(){
                    $.unblockUI();
                }, 100);
            };

            $(button).on("click", function(e){
                if ($('.process_reassignment_div').is(':hidden')) {
                    e.preventDefault();
                    e.stopPropagation();
                    unblock();

                    $('.process_reassignment_div').show();
                    $(button).css("position", "relative");
                    $(button).css("z-index", "100000");
                    $(button).closest(".form-button").css("position", "relative");
                    $(button).closest(".form-button").css("z-index", "100000");
                    $(element).trigger("chosen:updated");
                } else {
                    if ($(element).val() === "") {
                        e.preventDefault();
                        e.stopPropagation();
                        unblock();
                    } else {
                        return true;
                    }
                }
                return false;
            });

            $('.process_reassignment_div .blockui').on("click", function(){
                $('.process_reassignment_div').hide();
                $(button).css("z-index", "inherit");
                $(button).closest(".form-button").css("z-index", "inherit");
            });
        });
    </script>
</#if>
<#if renderClarificationDiv! == 'true' >
    <div class="process_clarify_div" style="position:relative; display:none;">
        <div class="blockui" style="width:100vw; height: 100vh; position: fixed; top:0; left:0; z-index: 99998; background: #000; opacity: 0.5;"></div>
        <div class="process_clarify_input" style="position:absolute; z-index: 100000; left: 50%; transform: translateX(-50%); top: -100px; padding:5px; background:#fff;">
            <div class='ui-screen-hidden'>
                <select id="process_clarifyact" name="process_clarifyact" style="display:none">
                    <option value=""></option>
                    <#list clarifyAct?keys as key>
                        <#if key! != ''>
                            <option value="${key!?html}">${clarifyAct[key]!?html}</option>
                        </#if>
                    </#list>
                </select>
            </div>
            <div style="width: 0; height: 0; border-right: 5px solid transparent; border-left: 5px solid transparent; border-top: 10px solid #fff; position: absolute; right: 50%; bottom: -10px; transform: translateX(50%);"></div>
        </div>
    </div>
    <style>
        body .form-container .process_clarify_div .chosen-container {width:250px !important; max-width:none;}
    </style>
    <script>
        $(function(){
            var button = $('#process_clarify');
            $(button).parent().append($('.process_clarify_div'));

            var element = $('#process_clarifyact');
            if ($("body").hasClass("rtl")) {
                $(element).addClass("chosen-rtl");
            }
            $(element).chosen({width: "250px", placeholder_text : '@@process.label.selectActivity@@'});
            var hidden = $(element).closest(".ui-screen-hidden");
            $(hidden).find(".chosen-container").insertAfter(hidden);

            var unblock = function () {
                setTimeout(function(){
                    $.unblockUI();
                }, 100);
            };

            $(button).on("click", function(e){
                if ($('.process_clarify_div').is(':hidden')) {
                    e.preventDefault();
                    e.stopPropagation();
                    unblock();

                    $('.process_clarify_div').show();
                    $(button).css("position", "relative");
                    $(button).css("z-index", "100000");
                    $(button).closest(".form-button").css("position", "relative");
                    $(button).closest(".form-button").css("z-index", "100000");
                    $(element).trigger("chosen:updated");
                } else {
                    if ($(element).val() === "") {
                        e.preventDefault();
                        e.stopPropagation();
                        unblock();
                    } else {
                        return true;
                    }
                }
                return false;
            });

            $('.process_clarify_div .blockui').on("click", function(){
                $('.process_clarify_div').hide();
                $(button).css("z-index", "inherit");
                $(button).closest(".form-button").css("z-index", "inherit");
            });
        });
    </script>
</#if>
<script>
    $(function(){
        var attachToolTip = function (button, tooltip) {
            console.log(button);
            console.log(tooltip);
            $(button).tooltipster({
                content: $("<div>" + tooltip + "</div>"),
                side: 'top'
            });
        };

        var attachConfirmation = function (button, msg) {
            $(button).on("click", function(e){
                if (confirm(msg)) {
                    return true;
                } else {
                    e.preventDefault();
                    e.stopPropagation();
                    unblock();
                    return false;
                }
            });
        };

        var tooltips = {
            'clarify' : '${element.properties.clarifyTooltip!}',
            'reassign' : '${element.properties.reassignTooltip!}',
            'withdraw' : '${element.properties.withdrawTooltip!}',
            'approve' : '${element.properties.approveTooltip!}',
            'reject' : '${element.properties.rejectTooltip!}'
        };
        var confirms = {
            <#if renderClarificationDiv! != 'true' >
                'clarify' : '${element.properties.clarifyConfirmation!}',
            </#if>    
            'withdraw' : '${element.properties.withdrawConfirmation!}',
            'approve' : '${element.properties.approveConfirmation!}',
            'reject' : '${element.properties.rejectConfirmation!}'
        };
        for (var property in tooltips) {
            if (tooltips.hasOwnProperty(property) && tooltips[property] !== "" && $('#process_'+property).length > 0) {
                attachToolTip($('#process_'+property), tooltips[property]);
            }
        }
        for (var property in confirms) {
            if (confirms.hasOwnProperty(property) && confirms[property] !== "" && $('#process_'+property).length > 0) {
                attachConfirmation($('#process_'+property), confirms[property]);
            }
        }
    });
</script>